﻿/*
	SPDX-License-Identifier: MIT
	Copyright © 2024-2025 Amebis
*/

#include "pch.hpp"

using namespace std;
#ifdef _WIN32
using namespace Microsoft::VisualStudio::CppUnitTestFramework;
#endif

namespace UnitTests
{
	void langid::from_rfc1766()
	{
		Assert::IsTrue(stdex::langid_from_rfc1766("en") == 9);
		Assert::IsTrue(stdex::langid_from_rfc1766("en-US") == 1033);
		Assert::IsTrue(stdex::langid_from_rfc1766("en_US") == 1033);
		Assert::IsTrue(stdex::langid_from_rfc1766("en-GB") == 2057);
		Assert::IsTrue(stdex::langid_from_rfc1766("en_GB") == 2057);
		Assert::IsTrue(stdex::langid_from_rfc1766("EN") == 9);
		Assert::IsTrue(stdex::langid_from_rfc1766("EN-US") == 1033);
		Assert::IsTrue(stdex::langid_from_rfc1766("EN_US") == 1033);
		Assert::IsTrue(stdex::langid_from_rfc1766("EN-GB") == 2057);
		Assert::IsTrue(stdex::langid_from_rfc1766("EN_GB") == 2057);

		Assert::IsTrue(stdex::langid_from_rfc1766("sl") == 36);
		Assert::IsTrue(stdex::langid_from_rfc1766("sl-SI") == 1060);
		Assert::IsTrue(stdex::langid_from_rfc1766("sl_SI") == 1060);
		Assert::IsTrue(stdex::langid_from_rfc1766("SL") == 36);
		Assert::IsTrue(stdex::langid_from_rfc1766("SL-SI") == 1060);
		Assert::IsTrue(stdex::langid_from_rfc1766("SL_SI") == 1060);
	}
}
